
local mvec3_dis_sq = mvector3.distance_sq
local mvec3_set = mvector3.set
local mvec3_set_z = mvector3.set_z
local mvec3_sub = mvector3.subtract
local mvec3_add = mvector3.add
local mvec3_mul = mvector3.multiply
local mvec3_norm = mvector3.normalize

local temp_vec1 = Vector3()

local tmp_ground_from_vec = Vector3()
local tmp_ground_to_vec = Vector3()
local up_offset_vec = math.UP * 30
local down_offset_vec = math.UP * -40
local win32 = SystemInfo:platform() == Idstring("WIN32")

local mvec_pos_new = Vector3()
local mvec_achieved_walk_vel = Vector3()
local mvec_move_dir_normalized = Vector3()

Hooks:Add("BaseNetworkSessionOnLoadComplete","gravemind_delayed_playerstandard_hooks",



	function()
	
		PlayerStandard.orig_standard_get_max_walk_speed = PlayerStandard._get_max_walk_speed
		function PlayerStandard:_get_max_walk_speed(...)
			if Gravemind:IsInMoment() then 
				return Gravemind.LIMP_SPEED
			end
			return self:orig_standard_get_max_walk_speed(...)
		end
		
		PlayerCarry.orig_carry_get_max_walk_speed = PlayerCarry._get_max_walk_speed
		function PlayerCarry:_get_max_walk_speed(...)
			if Gravemind:IsInMoment() then 
				return Gravemind.LIMP_SPEED
			end
			return self:orig_carry_get_max_walk_speed(...)
		end

		PlayerStandard.orig_check_action_steelsight = PlayerStandard._check_action_steelsight
		function PlayerStandard:_check_action_steelsight(...)
			if Gravemind:IsInMoment() then 
				self._steelsight_wanted = false
				return
			end
			return self:orig_check_action_steelsight(...)
		end
		
		PlayerMovementState.orig_update = PlayerMovementState.update
		function PlayerMovementState:update(t,...)
			if not Gravemind:IsInMoment() then 
				Gravemind:CheckPerformMoment(t,...)
			end
			return self:orig_update(t,...)
		end

		
		
		
		Gravemind:OnLoadComplete()
	end
	
	
	
	
	
)
